Subject: Re: tbench wrt. loopback TSO

From: Evgeniy Polyakov <[email-masked]>
Date: Mon, 27 Oct 2008 20:03:14 +0300

On Mon, Oct 27, 2008 at 05:19:17PM +0200, Ilpo Järvinen ([email-masked]) wrote:
> On Mon, 27 Oct 2008, Evgeniy Polyakov wrote:
> 
> > On Mon, Oct 27, 2008 at 09:49:21AM +0200, Ilpo Järvinen ([email-masked]) wrote:
> > > > > That's what I got with the current tree for 8 threads on a 4-way 32-bit
> > > > > Xeons (2 physical CPUs) and 8gb of ram:
> > > > > gso/tso off: 361.367
> > > > > tso/gso on:  354.635
> > > > 
> > > > Yes, it might do this, in which case tcp_tso_should_defer() simply needs
> > > > some tweaking.
> > > 
> > > Good point, could you Evgeniy verify first if simple goto send_now; in 
> > > beginning there recovers it all...
> > 
> > With direct goto at the begining of the tcp_tso_should_defer()
> > and 4403b406 commit git tree (was current yesterday night)
> > I got following numbers: 
> > 
> > with goto:
> > tso/gso  on: 358.976, 357.699
> > tso/gso off: 368.016, 367.079
> > 
> > no goto
> > tso/gso  on: 353.656, 354.791
> > tso/gso off: 364.8, 365.85
> > 
> > So tcp_tso_should_defer() adds additional problems not counted in
> > tso/gso changes.
> 
> Noticed that tcp_current_mss does modulo with tso and that it is 
> being called from a non-trivial number of places, though ovbiously only 
> part of them should be relevant here. ...I'm not sure if that can show 
> up though.

That's why when I see modulo something screams inside me...
I used following patch (without goto in the tcp_tso_should_defer():

diff --git a/net/ipv4/tcp_output.c b/net/ipv4/tcp_output.c
index e4c5ac9..8ee7597 100644
--- a/net/ipv4/tcp_output.c
+++ b/net/ipv4/tcp_output.c
@@ -1075,7 +1075,6 @@ unsigned int tcp_current_mss(struct sock *sk, int large_allowed)
 				  tp->tcp_header_len);
 
 		xmit_size_goal = tcp_bound_to_half_wnd(tp, xmit_size_goal);
-		xmit_size_goal -= (xmit_size_goal % mss_now);
 	}
 	tp->xmit_size_goal = xmit_size_goal;

tso/gso  on: 361.866 362.662
tso/gso off: 370.038 368.768

So this is another improvement hidden and not accounted in the tso/gso stuff.
Another modulo sits in tcp_mss_split_point().
Also found one in the scheduler's find_next_best_node(), which is under
CONFIG_NUMA though.

-- 
	Evgeniy Polyakov